#include "hank.h"
#include "hdt_blob.h"
#include "types.h"
#include <fcntl.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>

static char rcsid[] = "$Id: hdt_blob_test.c,v 1.9 2002/01/03 22:02:28 tlewis Exp $";

static char *patterns[] = {
	",,wxa",
	",,xaqq",
	",,qxax",
	NULL
};

unsigned char *text = "qxaxtqqpst";

extern struct memcon mmapmc;
struct memcon *mc = &mmapmc;

static void
open_file(char *filename, struct blob *b)
{
	int i;
	struct stat buf;

	/* This behavior is to mmap a file */
	if(stat(filename, &buf)){
		fprintf(stderr, "AIEE!  Can't stat file \"%s\"!  Exiting.\n", filename);
		exit(-1);
	}
	b->len=buf.st_size;
	i=open(filename, O_RDONLY);
	if((b->blob=mmap(NULL, b->len, PROT_READ, MAP_PRIVATE, i, 0))==MAP_FAILED){
		fprintf(stderr, "AIEE!  Can't mmap file \"%s\"!  Exiting.\n", filename);
		exit(-1);
	} else {
		printf("Mapped \"%s\" for length %i.\n", filename, b->len);
	}
}

static void
return_string(char *string, struct blob *b)
{
	b->blob=string;
	b->len=strlen(b->blob);
}

int
main(int ac, char *av[])
{
	hdt_set g, h;
	int i;
	unsigned char *rbuf;
	struct blob b;

	if(ac<3){
		printf("Usage: %s <text> <patterns...>\n", av[0]);
		exit(-1);
	}

	open_file(av[1], &b);

	g=hdt_blob_create();

#if 0
	for(i=0;patterns[i]!=NULL;i++){
		/* printf("Doing pattern \"%s\" (%i)\n", patterns[i], i); */
		hdt_blob_add(g, i, "acbm_match", patterns[i]);
		hdt_cblob_add(h, i, "acbm_match", patterns[i]);
	}
#else
	for(i=2;i<ac;i++){
		/* printf("Doing pattern \"%s\" (%i)\n", av[i], i); */
		rbuf=strdup(av[i]);
		hdt_blob_add(g, i, "acbm_case_match", rbuf);
		free(rbuf); rbuf=strdup(av[i]);
		hdt_blob_add(g, ac+i, "acbm_nocase_match", rbuf);
		free(rbuf);
	}
#endif

	rbuf=malloc(ac*2);
	memset(rbuf, 0, ac*2);

	/* printf("Testing with %s, %i\n", b.blob, b.len); */
	hdt_blob_match(g, NULL, &b, rbuf, 1);

	for(i=2;i<ac;i++){
		if(rbuf[i])
			printf("MATCH: caseful on %i, \"%s\"\n", i, av[i]);
		if(rbuf[ac+i])
			printf("MATCH: caseless on %i, \"%s\"\n", i, av[i]);
	}

	return(0);
}


