#ifndef   HANK_PACKET_H
#define   HANK_PACKET_H

/* Copyright 2001, Todd Lewis <tlewis@mindspring.com>
 * Released under GNU GPL v2. */

/* packet.h: defines packet structures */

#include "event.h"
#include "memcon.h" /* memcon_context */
#include "smodule.h"
#include <stdlib.h> /* size_t */
#include "types.h"  /* u_int32_t */

/* FORWARD DECLARATIONS */
struct candidate; /* defined below */
struct paengine;  /* defined in paengine.h */
struct protocol_engine;  /* defined in protocol_engine.h */

struct packet;
struct capsule;
struct entity;

/* DEFINITIONS */

typedef int prim_id;

/* is it unix or c that sucks?  I forget. */
struct hank_timeval {
	long tv_sec;		/* Seconds.  */
	long tv_usec;	/* Microseconds.  */
};

/* This is how a packet is thrown around */
struct packet {
	struct hank_timeval ts;
	struct paengine *paengine;	
	struct memcon_context *c;
	struct capsule *encaps;
	/* matches */
	/* actions */
	/* reports */
	u_int32_t verdict;
	u_int32_t id;
	struct event *q;
	int decomposed; /* this is a hack */
};

/* These are the sections of a protocol encapsulation. */
struct section {
	u_int32_t section_id; /* These id's are private to a pe */
	void *content;
	struct section *next;
};

struct capsule {
	struct section *sections; /* potentially unused; no guarantees */
	u_int32_t protocol;
	size_t length;
	u_int32_t payload_protocol;
	size_t payload_length;
	unsigned char *payload;
	struct protocol_engine *pe;
	struct capsule *next;
	struct packet *parent;
	unsigned char *matches;
};

#endif /* HANK_PACKET_H */

