<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:fo="http://www.w3.org/1999/XSL/Format">

<xsl:output method="text"/>

<!-- skipped elements; these are used in the docs -->
<xsl:template match="desc"/>
<xsl:template match="p"/>
<xsl:template match="ref"/>
<xsl:template match="ref-rfc"/>

<xsl:template match="miscelem"><xsl:text>
</xsl:text><xsl:value-of select="mtype"/> DELETE <xsl:value-of select="mvalue"/>
</xsl:template>

<xsl:template match="miscelems">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="rcsid">
R(<xsl:copy-of select="node()"/>)
</xsl:template>

<xsl:template match="pe">
<xsl:if test="@disabled='yes'">
Disabled
</xsl:if>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="name">
N <xsl:copy-of select="node()"/>
 DELETE
</xsl:template>

<xsl:template match="protocols">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template name="family" match="family"><xsl:copy-of select="node()"/></xsl:template>
<xsl:template name="number" match="number"><xsl:copy-of select="node()"/></xsl:template>

<xsl:template match="protocol">
P(<xsl:apply-templates select="family"/>,<xsl:apply-templates select="number"/>)
 DELETE
</xsl:template>

<xsl:template match="endian">
E <xsl:copy-of select="node()"/>
 DELETE
</xsl:template>

<xsl:template name="proto" match="proto"><xsl:copy-of select="node()"/></xsl:template>
<xsl:template name="hlen" match="hlen"><xsl:copy-of select="node()"/></xsl:template>

<xsl:template match="decompose">
D(<xsl:apply-templates select="family"/>,<xsl:apply-templates select="proto"/>,<xsl:apply-templates select="hlen"/>)
 DELETE
</xsl:template>

<xsl:template match="sections">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="section">
S <xsl:value-of select="@name"/>
 DELETE
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="reversal">
B
	<xsl:apply-templates/>
B
 DELETE
</xsl:template>

<xsl:template match="custom_type">
O <xsl:value-of select="@name"/> DELETE <xsl:value-of select="@type"/>
 DELETE
</xsl:template>

<xsl:template match="blob">
C <xsl:value-of select="@name"/>
 DELETE
</xsl:template>

<xsl:template match="int32">
	<xsl:choose>
		<xsl:when test="@len=8">
X <xsl:value-of select="@name"/> DELETE <xsl:value-of select="@len"/>
		</xsl:when>
		<xsl:when test="@len=16">
X <xsl:value-of select="@name"/> DELETE <xsl:value-of select="@len"/>
		</xsl:when>
		<xsl:when test="@len=32">
X <xsl:value-of select="@name"/> DELETE <xsl:value-of select="@len"/>
		</xsl:when>
		<xsl:when test="@len&gt;32">
Y <xsl:value-of select="@name"/> DELETE <xsl:value-of select="@len div 8"/>
		</xsl:when>
		<xsl:otherwise>
Z <xsl:value-of select="@name"/> 32 <xsl:value-of select="@len"/>
		</xsl:otherwise>
	</xsl:choose>
 DELETE
</xsl:template>

<xsl:template match="/">
	<xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
