static int
oncrpc_private_decompose (struct packet *p)
{
  struct capsule *e = p->encaps, *f;
  struct ONCRPC_Hdr *h;
  struct section *s, *t;
  int tcpudp= 0;

  while (e->next){
  	if(e->protocol == ((HPN_IPV4<<24) | 6)) /* tcp */
		tcpudp=1;
  	if(e->protocol == ((HPN_IPV4<<24) | 17)) /* udp */
		tcpudp=2;

    e = e->next;
  }

	/* viz. rfc 1050, section 10. */
	if(tcpudp==1)
  		h = (struct ONCRPC_Hdr *) &e->payload[4];
	else 
  		h = (struct ONCRPC_Hdr *) e->payload;

	printf("ONCRPC: xid %i, direction %i.\\n",
		htonl(h->xid),
		htonl(h->direction));

  append_encap (p, protocols[0], e->payload_length, e->payload);
  f = e->next;
  f->pe = &oncrpc_pe;

  if ((s = p->c->eng->alloc (p->c, sizeof (*s))) == NULL)
    exit (-1);

  if ((t = p->c->eng->alloc (p->c, sizeof (*t))) == NULL)
    exit (-1);

  s->section_id = ONCRPC_SECTION_Hdr;
  s->content = h;
  s->next = t;

  switch(htonl(h->direction)){

  	case 0: /* CALL */
  		t->section_id=ONCRPC_SECTION_call_body;
		break;

  	case 1: /* REPLY*/
  		t->section_id=ONCRPC_SECTION_reply_body;
		break;

	default:
		printf("AIEE!  Unrecognized oncrpc direction: %i\\n", htonl(h->direction));
  }

  t->content = &(h->payload);
  t->next=NULL;

  f->sections = s;

  return (0);
}

