
#define PRINTF(x...) 

/* private functions */

static int
XXXPROTO_field_lookup(char *section, char *field)
{
	int p = -1;

	if((section==NULL) && (field==NULL)){
		p=XXXCPROTO_SELF;
	} else if(section!=NULL && !(strcmp(section, "INVALID"))) {
		p=XXXCPROTO_FIELD_INVALID;
#define S(s) \
	} else if ( (section==NULL) || (!(strcmp(section, #s))) ) {\
		if(field==NULL)\
			p=XXXCPROTO_FIELD_##s;
#define X(s,a,b,c) Y(s,a,b)
#define O(s,a,b) Y(s,a,b)
#define Z(s,a,b,c,d) Y(s,a,c)
#define C(s,a) Y(s,a,"foo")
#define Y(s,a,b) \
		else if(!(strcmp(field, #a)))\
			p = XXXCPROTO_FIELD_ ## s ## _ ## a;
#include "XXXPROTO.hx"
#undef S
#undef O
#undef X
#undef Y
#undef Z
#undef C
	}

	if(p == -1){
		printf("XXXCPROTO: Unrecognized field: \\" %s \\".  Returning error.\\n", field);
		return(XXXCPROTO_FIELD_INVALID);
	}

	PRINTF("For section %s, field %s, returning %i.\\n", section, field, p);
	return(p);
}

/* Public function implementations */

/* This is a stock decompose function for simple protocols.
   If your protocol is even slightly complicated in its composition,
	then you may well have to provide your own decomp function.  Take
	a look at the icmp pe for an example. */
static int 
XXXPROTO_stock_decompose(struct packet *p)
{
	struct capsule *e = p->encaps, *f;
	struct XXXCPROTO_Hdr *h;
	struct section *s;

	/* find the preceeding capsule */
	while(e->next)
		e=e->next;

	h=(struct XXXCPROTO_Hdr *)e->payload;

	/* Ok, we need to add out own encap */
	append_encap(p, protocols[0], e->payload_length, e->payload);
	f=e->next;
	f->pe = &XXXPROTO_pe;

	if((s=p->c->eng->alloc(p->c, sizeof(*s)))==NULL)
		exit(-1);
	s->section_id=XXXCPROTO_SECTION_Hdr;
	s->content=h;
	s->next=NULL;
	f->sections=s;
	f->length=e->payload_length;

	/* If we're a carrier protocol, then we need to mark our payload */
#define D(pfam,protocol,hlen)                                  \
	f->payload_length=(f->length - hlen );                      \
	f->payload_protocol=(u_int32_t)((HPN_ ##pfam<<24)|protocol);\
	f->payload = &(e->payload[hlen]); \
	/* printf("XXXCPROTO created payload of proto %i, location %x, length %i.\\n", \
		protocol, f->payload, f->payload_length); */

#include "XXXPROTO.hd"
#undef D

	return(0);
}

static int
XXXPROTO_stock_reg_prim(int field, char *op, char *arg)
{
	int prid = ++gprid;

	/* if section defined, then lookup */
	/* use section (if present) to find field */

	PRINTF("XXXCPROTO: REGISTERING PRIMITIVE: %i\\n", prid);

	if(field==XXXCPROTO_FIELD_INVALID){
		printf("XXXCPROTO: Error.  Received invalid field in reg_prim(), op=%s, arg=%s.\\n", op, arg);
		return(-1);
	}


	if(!strcmp(op, "present")){
		struct simple_prim *p;

		if(!(p=malloc(sizeof(*p))))
			exit(-1);
		p->prim=prid;

		if(field==XXXCPROTO_SELF){
			/* add simple_prim to present_sections.proto_self; */
			p->next=present_sections.proto_self;
			present_sections.proto_self=p;
			return(prid);

#define S(a) \
		} else if(field==XXXCPROTO_FIELD_ ##a){ \
			/* for each section, test and add */ \
			p->next=present_sections.present_##a; \
			present_sections.present_##a=p; \
			return(prid);

#define O(s,a,b)
#define X(s,a,b,c)
#define Y(s,a,b)
#define Z(s,a,b,c,d)
#define C(s,a)
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef C
#undef S

		}

		printf("That shit (%i) ain't keepin' it real.\\n", field);
		return(-1);
	}

/* cpp: providing polymorphism to real men for over 30 years */
#define C(s,a) \
	if(field==XXXCPROTO_FIELD_ ## s ## _ ## a){ \
		if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
			hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]=hdt_blob_create(); \
			PRINTF("REG_PRIM: Assigned hdt_sets[ %i ] to %i\\n", \
				XXXCPROTO_FIELD_ ## s ## _ ## a, \
				hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]); \
			if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
				printf("AIEE!  Can't add match set for %s.%s!  Exiting.\\n", #s, #a); \
				exit(-1); \
			} \
		} \
		if(hdt_blob_add(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a], prid, op, arg)) { \
			printf("Error adding primitive %s in XXXPROTO!\\n", op); \
			return(-1); \
		} else { \
			PRINTF("Added op %s, arg %s to hdt_blob.\\n", op, arg); \
		} \
		return(prid); \
	}

#define O(s,a,b) \
	if(field==XXXCPROTO_FIELD_ ## s ## _ ## a){ \
		if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
			hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]=hdt_ ## b ## _create(); \
			PRINTF("REG_PRIM: Assigned hdt_sets[ %i ] to %i\\n", \
				XXXCPROTO_FIELD_ ## s ## _ ## a, \
				hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]); \
			if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
				printf("AIEE!  Can't add %s match set for %s.%s!  Exiting.\\n", #b, #s, #a); \
				exit(-1); \
			} \
		} \
		if(hdt_ ## b ## _add(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a], prid, op, arg)) { \
			printf("Error adding primitive %s in XXXPROTO!\\n", op); \
			return(-1); \
		} else { \
			PRINTF("Added op %s, arg %s to hdt_%s.\\n", op, arg, #b); \
		} \
		return(prid); \
	}

#define X(s,a,b,c) \
	if(field==XXXCPROTO_FIELD_ ## s ## _ ## a){ \
		if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
			hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]=hdt_int32_create(); \
			if(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a]==0){ \
				printf("AIEE!  Can't add int match set for %s.%s!  Exiting.\\n", #s, #a); \
				exit(-1); \
			} \
		} \
		if(hdt_int32_add(hdt_sets[XXXCPROTO_FIELD_ ## s ## _ ## a], prid, op, arg)) { \
			printf("Error adding primitive %s in XXXPROTO!\\n", op); \
			return(-1); \
		} else { \
			PRINTF("Added op %s, arg %s to hdt_int32.\\n", op, arg); \
		} \
		return(prid); \
	}

#define Z(s,a,b,c,d) X(s,a,c,d)
#define Y(a,b,c) /* FIXME: add array matching */
#define S(section)
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef S
#undef C

	return(-1);
}

static int
XXXPROTO_stock_unreg_prim(prim_id i)
{
	/* needs implementing */
	return(-1);
}

static int
XXXPROTO_stock_rewrite (struct capsule *c, void *new_payload, SIZE_T len)
{
	if((c!=NULL) && (new_payload!=NULL))
		len++;
	return(-1);
}

static char *
XXXPROTO_stock_report_field(struct capsule *cp, int field, struct memcon_context *m)
{
	SIZE_T t;
	char *r, buf[1024]; /* should be enough */
	struct section *sec, *sec2;

	buf[0]=0;

	switch(field){

#define S(s)
#define Y(s,a,b) \
		case(XXXCPROTO_FIELD_ ##s##_ ##a): \
			sec=NULL; \
			for(sec2=cp->sections;sec2;sec2=sec2->next){ \
				if(sec2->section_id == XXXCPROTO_SECTION_ ## s) \
					sec=sec2; \
			} \
			if(sec) { \
				int i; \
				unsigned char c; \
				\
				buf[0]='0'; \
				buf[1]='x'; \
				for(i=0;i<b;i++){ \
					c = ((struct XXXCPROTO_ ## s *)(sec->content))-> ## a ## [i]; \
					buf[(i*2)+2] = hexes[c>>4]; \
					buf[(i*2)+3] = hexes[c&0xf]; \
					buf[(i*2)+4] = 0; \
				} \
			} else { \
				snprintf(buf, sizeof(buf), "(section %s not present)", #s); \
			} \
			break;

#define X(s,a,b,c) \
		case(XXXCPROTO_FIELD_ ##s##_ ##a): \
			sec=NULL; \
			for(sec2=cp->sections;sec2;sec2=sec2->next){ \
				if(sec2->section_id == XXXCPROTO_SECTION_ ## s) \
					sec=sec2; \
			} \
			if(sec) { \
				snprintf(buf, sizeof(buf), "%u",  \
					c ## ( ((struct XXXCPROTO_ ## s *)(sec->content))-> ## a) ); \
			} else { \
				snprintf(buf, sizeof(buf), "(section %s not present)", #s); \
			} \
			break;

#define Z(s,a,b,c,d) X(s,a,c,d)

#define C(s,a) /* ccontent skipped; no reporting until parameterized matching */

#define O(s,a,b) \
		case(XXXCPROTO_FIELD_ ##s##_ ##a): \
			sec=NULL; \
			for(sec2=cp->sections;sec2;sec2=sec2->next){ \
				if(sec2->section_id == XXXCPROTO_SECTION_ ## s) \
					sec=sec2; \
			} \
			if(sec) { \
				return ( hdt_ ## b ## _report( ((struct XXXCPROTO_ ## s *)(sec->content))-> ## a, m) ); \
			} \
			snprintf(buf, sizeof(buf), "(section not present)"); \
			break;

#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef S
#undef C

		default:
			/* FIXME: log */
			return(NULL);
	}
	t=(strlen(buf)+1);
	r=m->eng->alloc(m, t);
	strncpy(r, buf, t);
	return(r);
}

static int
XXXPROTO_stock_find_matches(struct capsule *cp, struct prim_can *p)
{
	struct section *s;
	struct memcon_context *c = cp->parent->c;
	u_int32_t v;
	unsigned long beg, end;

	if(p)
		return(-1); /* we don't do piecemeal matching yet */

	if(cp->matches==NULL && gprid){
		if(!(cp->matches=c->eng->alloc(c, gprid+1)))
			exit(-1);
		memset(cp->matches,0,gprid+1);
		/* use prid 0 for all tests known to be true, like ipv4 0/0 */
		cp->matches[0]=1;
	}


	/* foreach section present */
	for(s=cp->sections;s;s=s->next){
		struct simple_prim *sp;

		for(sp=present_sections.proto_self;sp;sp=sp->next){
			PRINTF("SETTING proto_self matches for XXXCPROTO.\\n");
			cp->matches[sp->prim] |= 1;
		}

		/* foreach registered field in that section */
		switch(s->section_id){
			case XXXCPROTO_SECTION_INVALID:
				return(-1);

#define S(sec) \
				break; \
			case XXXCPROTO_SECTION_ ## sec: \
				PRINTF("Evaluating section %s.\\n", #sec ); \
				for(sp=present_sections.present_ ## sec ;sp;sp=sp->next) {\
					/* printf("SETTING present_sections matches for XXXCPROTO, sec %s.\\n", #sec); */ \
					cp->matches[sp->prim] |= 1;\
				}

#define X(sec,a,b,c) \
				rdtscl(beg); \
				if(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a]){ \
					PRINTF("Evaluating field %s.\\n", #a ); \
					/* there's a registered set for this field */ \
					v= c ## ( ((struct XXXCPROTO_ ## sec *)(s->content))-> ## a ); \
					PRINTF("Testing field %s/%s, val = %i.\\n", #sec, #a, v); \
					if(hdt_int32_match(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a], \
						NULL, v, cp->matches, 1)) { \
							printf("AIEE!  Can't find int match.  Exiting.\\n"); \
							exit(-1); \
					} \
				} \
				rdtscl(end); \
				printf("Matching on field %s:%s took %lu cycles.\\n", \
					#sec, #a, (end-beg));

#define Z(s,a,b,c,d) X(s,a,c,d)
#define Y(a,b,c)

#define O(sec,a,b) \
				rdtscl(beg); \
				if(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a]){ \
					PRINTF("Evaluating field %s.\\n", #a ); \
					/* there's a registered set for this field */ \
					if(hdt_ ## b ## _match(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a], \
						NULL, \
						((struct XXXCPROTO_ ## sec *)(s->content))-> ## a, \
						cp->matches, 1)) { \
							printf("AIEE!  Can't find %s match.  Exiting.\\n", #b ); \
							exit(-1); \
					} \
				} \
				rdtscl(end); \
				printf("Matching on field %s:%s took %lu cycles.\\n", \
					#sec, #a, (end-beg));

#define C(sec,a) \
				rdtscl(beg); \
				if(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a]){ \
					struct blob bb; \
					\
					bb.blob = &(((struct XXXCPROTO_ ## sec *)(s->content))-> ## a); \
					bb.len = cp->length - offsetof(struct XXXCPROTO_ ## sec, a); \
					PRINTF("Evaluating field %s.\\n", #a ); \
					/* there's a registered set for this field */ \
					if(hdt_blob_match(hdt_sets[XXXCPROTO_FIELD_ ## sec ## _ ## a], \
						NULL, &bb, \
						cp->matches, 1)) { \
							printf("AIEE!  Can't find blob match.  Exiting.\\n"); \
							exit(-1); \
					} \
				} \
				rdtscl(end); \
				printf("Matching on field %s:%s took %lu cycles.\\n", \
					#sec, #a, (end-beg));

#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef S
#undef C

				break;
			default:
				printf("Unrecognized section: %i (not %i).\\n", s->section_id, XXXCPROTO_SECTION_Hdr);
				break;
		}
	}

	return(-1);
}
