
#define SIZE_T u_int32_t

#define R(x) static char rcsid[] = x ;
#include "XXXPROTO.hr"
#undef R

#define STATIC_MODULE_NAME XXXPROTO

#ifdef ENABLE_DYN_MODULES
extern struct smodule *protocol_engine[];
#else /*ENABLE_DYN_MODULES */
extern struct smodule *STATIC_MODULE_NAME[];
#endif				/*ENABLE_DYN_MODULES */

extern struct protocol_engine XXXPROTO_pe;

#define bs8(x) x
#define bs16(x) ntohs(x)
#define bs32(x) ntohl(x)
#define identity(x) x

static u_int32_t protocols[] = {
#define P(x,y) ((HPN_ ##x << 24) | y),
#include "XXXPROTO.hp"
#undef P
0
};

struct simple_prim {
	prim_id prim;
	struct simple_prim *next;
};

static struct {
	struct simple_prim *proto_self;
#define S(a) struct simple_prim *present_##a;
#define O(s,a,b)
#define X(s,a,b,c)
#define Y(s,a,b)
#define Z(s,a,b,c,d)
#define C(s,a)
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef C
#undef S
} present_sections;

enum XXXCPROTO_FIELD
{
	XXXCPROTO_SELF,
#define S(a) XXXCPROTO_FIELD_ ##a,
#define O(s,a,b) XXXCPROTO_FIELD_ ##s## _ ##a ,
#define X(s,a,b,c) XXXCPROTO_FIELD_ ##s## _ ##a ,
#define Y(s,a,b) XXXCPROTO_FIELD_ ##s## _ ##a ,
#define Z(s,a,b,c,d) XXXCPROTO_FIELD_ ##s## _ ##a ,
#define C(s,a) XXXCPROTO_FIELD_ ##s## _ ##a ,
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef C
#undef S
  XXXCPROTO_FIELD_INVALID
};

enum XXXCPROTO_SECTIONS
{
#define S(a) XXXCPROTO_SECTION_ ##a,
#define O(s,a,b)
#define X(s,a,b,c) 
#define Y(s,a,b)
#define Z(s,a,b,c,d)
#define C(s,a)
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef C
#undef S
  XXXCPROTO_SECTION_INVALID
};

struct XXXCPROTO_null{
	int empty;
#define S(s) \
}; \
/* s */ \
struct XXXCPROTO_##s {
#define O(s,a,b) b a;
#define X(s,a,b,c) u_int ## b ##_t a;
#define Y(s,a,b) u_int8_t a[b];
#define Z(s,a,b,c,d) b a:c;
#define C(s,a) unsigned char a;
#include "XXXPROTO.hx"
#undef O
#undef X
#undef Y
#undef Z
#undef C
#undef S
};

#define REG_PRIM XXXPROTO_stock_reg_prim
#define UNREG_PRIM XXXPROTO_stock_unreg_prim
#define DECOMPOSE XXXPROTO_stock_decompose
#define FIND_MATCHES XXXPROTO_stock_find_matches
#define REWRITE XXXPROTO_stock_rewrite
#define GET_INT_FIELD XXXPROTO_stock_get_int_field
#define GET_ARRAY_FIELD XXXPROTO_stock_get_array_field
#define REPORT_FIELD XXXPROTO_stock_report_field
#define FIELD_LOOKUP XXXPROTO_field_lookup

static char hexes[] = "0123456789abcdef";

static int gprid=0;

static hdt_set hdt_sets[XXXCPROTO_FIELD_INVALID];

#include "XXXPROTO.hv"

/* prototypes */
static int XXXPROTO_stock_reg_prim(int field, char *op, char *arg);
static int XXXPROTO_stock_unreg_prim (prim_id i);
static int XXXPROTO_stock_decompose (struct packet *p);
static int XXXPROTO_stock_find_matches (struct capsule *cp, struct prim_can *c);
static int XXXPROTO_stock_rewrite (struct capsule *c, void *new_payload,
			     SIZE_T len);
static char *XXXPROTO_stock_report_field (struct capsule *p, int field,
				    struct memcon_context *m);
static int XXXPROTO_field_lookup(char *section, char *field);

struct protocol_engine XXXPROTO_pe = {
  {
   "pe",
   "XXXPROTO",
   PEVMIN,
   PEVMAJ,
   &XXXPROTO_pe
  },
  &DECOMPOSE,
  &REG_PRIM,
  &UNREG_PRIM,
  &FIND_MATCHES,
  &REWRITE,
  &REPORT_FIELD,
  &FIELD_LOOKUP,
  &protocols[0],
  0
};

#define STATIC_MODULE_NAME XXXPROTO

#ifdef ENABLE_DYN_MODULES
struct smodule *protocol_engine[] = {
#else /*ENABLE_DYN_MODULES */
struct smodule *STATIC_MODULE_NAME[] = {
#endif				/*ENABLE_DYN_MODULES */
  &(XXXPROTO_pe.s),
  NULL
};

