#ifndef SMODULE_H
#define SMODULE_H

/* smodule.h - (c) 2001, Todd Lewis, tlewis@mindspring.com
 * Released under GNU GPL v2.
 * This is the interface definition for the simple module system.
 * See the smodule rfc for details on this system.
 */

typedef int smcol_t;

struct smodule {
	const char *sysname;
	const char *name;
	unsigned int vmaj;
	unsigned int vmin;
	void *interface;
};

struct collections {
	smcol_t paengines;
	smcol_t memcons;
	smcol_t matchers;
	smcol_t processors;
	smcol_t protocol_engines;
	smcol_t system_logs;
};

struct smodule_juggler {
	smcol_t (*scan_collection)(const char *mod_name, struct smodule ***statics,
		const char **dirs, unsigned int vmaj, unsigned int vmin);
	void (*release_collection)(smcol_t collection);
	struct smodule *(*get_smodule)(smcol_t collection, const char *name);
	void (*release_smodule)(smcol_t collection, struct smodule *mod);
};

extern struct smodule *static_paengines[];
extern struct smodule *static_memcons[];
extern struct smodule *static_matchers[];
extern struct smodule *static_processors[];
extern struct smodule *static_protocol_engines[];
extern struct smodule *static_system_logs[];

extern struct smodule_juggler *master_smodule_juggler;
extern struct collections *master_collections;

#endif /*SMODULE_H*/
