#!/usr/bin/perl

$rcsid = ' $Id: snort_converter.pl,v 1.17 2001/12/08 00:04:48 tlewis Exp $ ';

sub mylc() {
	my $xproto=lc(shift(@_));
	if($xproto eq "ip"){
		$xproto="ipv4";
	}
	return($xproto);
}

# alert tcp $EXTERNAL_NET any -> $HTTP_SERVERS 80 (msg:"WEB-IIS webdav file lock attempt"; flags:A+; content:"LOCK "; offset:0; depth:5; reference:bugtraq,2736; classtype:bad-unknown; sid:969; rev:1;)

$RULES_DIR=".";

$dbg=1;  # Debugging?
$mode = $ARGV[0];
$header=1;
# print "XXX: Using mode $mode\n";

sub check_header(){
	if($mode){
		if($header){
			print << 'EOF';
]>

EOF

			$date = `date`;
			chomp($date);
			print "<!-- (snort_converter.pl version $rcsid) -->\n";
			print "<!-- $0 run at $date  -->\n";
			print << 'EOF';
<hank-rules>
<decomp>Automated filler</decomp>
<rules>
EOF

			$header=0;
		}
	}
}

if($mode){
	print << 'EOF';
<?xml version="1.0"?>
<!DOCTYPE hank-rules
SYSTEM "rules.dtd" [
EOF
}


while(<STDIN>){
	chomp;
	next if (/^\w*$/ || /^#/ || /^preprocessor/);

	if(/^var/) {
		if($mode && $header){
			@A=split;
			if($A[1] eq "RULES_DIR") {
				if ($dbg) { print "0: $A[0] 1: $A[1] 2: $A[2]\n" }
				$RULES_DIR=$A[2];
			} elsif($A[2] eq "any"){
				$A[2] = "0/0";
			}
			if($A[2] =~ /^\$/){
				$A[2] =~ s/^\$//g;
				$vars{$A[1]} = $vars{$A[2]};
			} else {
				$vars{$A[1]} = $A[2];
			}
			print("<!ENTITY $A[1] \"$vars{$A[1]}\">\n");
		}
	} elsif(/^alert/) {
		&check_header();
		($comment = $_) =~ s/--/- -/g;
		print("<!-- $comment -->\n\n");
		print "<rule>\n";

		$line = $_;

		($header, $options) = split(/ \(/, $line);
		$options =~ s/\)$//g;

		@headers=split(/ /, $header);
		@options=split(/;/, $options);

		for($i=0;$i<$#headers;$i++){
			$headers[$i] =~ s/&/&amp\;/g;
			$headers[$i] =~ s/</&lt\;/g;
			$headers[$i] =~ s/>/&gt\;/g;
		}

		for($i=0;$i<$#options;$i++){
			$options[$i] =~ s/&/&amp\;/g;
			$options[$i] =~ s/</&lt\;/g;
			$options[$i] =~ s/>/&gt\;/g;
		}

		$i=0;
		$cont=1;

		print("\t<collection>\n");

		while($cont){
			($op, $val) = split(/:/, $options[$i]);

			# TODO: logto, 
			if($op =~ /msg/){
				$val =~ s/^"//g;
				$val =~ s/"$//g;
				print "\t\t<report>$val</report>\n";
				splice(@options,$i,1);
			} elsif($op =~ /reference/){
				print "\t\t<reference>$val</reference>\n";
				splice(@options,$i,1);
			} elsif($op =~ /classtype/){
				print "\t\t<classtype>$val</classtype>\n";
				splice(@options,$i,1);
			} elsif($op =~ /sid/){
				print "\t\t<sid>$val</sid>\n";
				splice(@options,$i,1);
			} elsif($op =~ /rev/){
				print "\t\t<rev>$val</rev>\n";
				splice(@options,$i,1);
			} else {
				$val =~ s/^ *//g; $val =~ s/ *$//g;
				$op =~ s/^ *//g;  $op =~ s/ *$//g;
				$params{$op} = $val;
				# print("Skipping $op\n");
				$i++;
			}

			if($i >= $#options){
				$cont=0;

			} else {
				# print("$i < $#options, continuing\n");
			}
		}

		print("\t</collection>\n");
		print("\t<match>\n");
		print("\t\t<AND>\n");

		if($headers[2] =~ /^\$/){
			$headers[2] =~ s/^\$//g;
			$headers[2] = "&$headers[2];";
		}
		print "\t\t\t<PRIM proto=\"ipv4\" field=\"source\" op=\"&lt;\">$headers[2]</PRIM>\n";

		if($headers[3] =~ /^\$/){
			$headers[3] =~ s/^\$//g;
			$headers[3] = "&$headers[3];";
		}
		if($headers[3] =~ /[0-9]/){
			my $lproto=&mylc($headers[1]);
			if($lproto eq "tcp" || $lproto eq "udp"){
				# FIXME: deal with ranges, "start:end"
				print "<NOT>" if($headers[3] =~ /!/);
				($ports = $headers[3]) =~ s/!//g;
				if($ports =~ /:/){
					($start, $end) = split(/:/, $ports);
					if($start eq $end && $start eq ""){
						print(STDERR "AIEE!  Error in line; both sides of port range are null.\n$_\nExiting.\n");
						exit(-1);
					} elsif ($start eq ""){
						$end++;
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"source_port\" op=\"&lt;\">$end</PRIM>\n";
					} elsif ($end eq ""){
						$start--;
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"source_port\" op=\"&gt;\">$start</PRIM>\n";
					} else {
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"source_port\" op=\":\">$start-$end</PRIM>\n";
					}
				} else {
					print "\t\t\t<PRIM proto=\"$lproto\" field=\"source_port\" op=\"=\">$ports</PRIM>\n";
				}
				print "</NOT>" if($headers[3] =~ /!/);
			}
		}

		if($headers[5] =~ /^\$/){
			$headers[5] =~ s/^\$//g;
			$headers[5] = "&$headers[5];";
		}
		print "\t\t\t<PRIM proto=\"ipv4\" field=\"destination\" op=\"&lt;\">$headers[5]</PRIM>\n";

		if($headers[6] =~ /^\$/){
			$headers[6] =~ s/^\$//g;
			$headers[6] = "&$headers[6];";
		}
		if($headers[6] =~ /[0-9]/){
			my $lproto=&mylc($headers[1]);
			if($lproto eq "tcp" || $lproto eq "udp") { 
				# FIXME: deal with ranges, "start:end"
				print "<NOT>" if($headers[6] =~ /!/);
				($ports = $headers[6]) =~ s/!//g;
				if($ports =~ /:/){
					($start, $end) = split(/:/, $ports);
					if($start eq $end && $start eq ""){
						print(STDERR "AIEE!  Error in line; both sides of port range are null.\n$_\nExiting.\n");
						exit(-1);
					} elsif ($start eq ""){
						$end++;
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"destination_port\" op=\"&lt;\">$end</PRIM>\n";
					} elsif ($end eq ""){
						$start--;
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"destination_port\" op=\"&gt;\">$start</PRIM>\n";
					} else {
						print "\t\t\t<PRIM proto=\"$lproto\" field=\"destination_port\" op=\":\">$start-$end</PRIM>\n";
					}
				} else {
					print "\t\t\t<PRIM proto=\"$lproto\" field=\"destination_port\" op=\"=\">$ports</PRIM>\n";
				}
				print "</NOT>" if($headers[6] =~ /!/);
			}
		}

		# Match options
		$has_content=0;
		$content=$offset=$depth=$nocase='';
		for($i=0;$i<$#options;$i++){
			($op, $val) = ('', '');
			($op, $val) = split(/: */, $options[$i]);

			$op =~ s/^ *//g;  $op =~ s/ *$//g;

			if($op =~ /content/){

				if($has_content){
					if( !($op =~ /content/) && !($op =~ /depth/) &&
					!($op =~ /offset/) && !($op =~ /nocase/) ){
						# spit it out
						# print("NO CONTENT MATCH: $op\n");
						my $lproto=&mylc($headers[1]);
						if($lproto eq "icmp"){ # God does this suck.
							$offset += 4;
						}
						if($nocase){
							print "\t\t\t<PRIM proto=\"$lproto\" field=\"payload\" op=\"acbm_nocase_match\">$offset,$depth,$content</PRIM>\n";
						} else {
							print "\t\t\t<PRIM proto=\"$lproto\" field=\"payload\" op=\"acbm_case_match\">$offset,$depth,$content</PRIM>\n";
						}
						$content=$offset=$depth=$nocase='';
						$has_content=0;
					}
				}

				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				# N.b., this will get uricontent, too.
				$val =~ s/^ *"//g;
				$val =~ s/" *$//g;
				$content=$val;
				$has_content=1;

			} elsif($op =~ /fragbits/){
				# similar to 'flags'
				# grep fragbits *| sed 's/^.*fragbits: *//g'|sed 's/;.*$//g'|sort|uniq|xargs
				# present uses: M M+ R
				# R - reserved bit
				# M - more fragments
				# D - don't fragment
				$val =~ s/^ *"//g;
				$val =~ s/" *$//g;
				$o="=";
				$a=0;
				$inverted=0;
				$l=length($val);
				for($j=0;$j<$l;$j++){
					$v = substr($val,$j,1);
					if($v eq ' '){
					} elsif($v eq '+'){
						$o = "mask_all";
					} elsif($v eq '*'){
						$o = "mask";
					} elsif($v eq '!'){
						$inverted=1;
					} elsif($v eq '0'){
						# $a |= 0;
					}
				}
				print "\t\t\t<PRIM proto=\"ipv4\" field=\"flags_offset\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /ipoption/){
				#FIXME!!  Need ip option support in ipv4 pe
				# print "\t\t\t<PRIM proto=\"ipv4\" field=\"\" op=\"=\">$val</PRIM>\n";
			
			} elsif($op =~ /icmp_id/i){
				print "\t\t\t<PRIM proto=\"icmp\" section=\"Echo\" field=\"id\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ "id"){
				# FIXME: I think this is right, but it's untested.
				print "\t\t\t<PRIM proto=\"ipv4\" field=\"id\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /ttl/i){
				print "\t\t\t<PRIM proto=\"ipv4\" field=\"ttl\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /tos/){
				print "\t\t\t<PRIM proto=\"ipv4\" field=\"tos\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /same_ip/){
				print "\t\t\t<PRIM proto=\"ipv4\" field=\"id\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /icmp_seq/){
				print "\t\t\t<PRIM proto=\"icmp\" section=\"Echo\" field=\"id\" op=\"=\">$val</PRIM>\n";

			} elsif($op =~ /ip_proto/){
				# In future, change this to a generic IP and the xsl it to v4|v6
				$proto=$val;
				if($proto =~ /[a-zA-Z]/){
					$proto = getprotobyname($proto);
				}
				if($proto =~ /^!/){
					print "\t\t\t<NOT><PRIM proto=\"ipv4\" field=\"protocol\" op=\"=\">$proto</PRIM></NOT>\n";
				} else {
					print "\t\t\t<PRIM proto=\"ipv4\" field=\"protocol\" op=\"=\">$proto</PRIM>\n";
				}

			} elsif($op =~ /flags/){
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				# Here are the presently (9/17/01) present flags:
				# 0 A A+ AP F FPU PA PA12 S SA SF SF12 SFP SFPU SFU12 SRAFPU a+ 
				# FIXME: make reasonable
				$val =~ s/^ *"//g;
				$val =~ s/" *$//g;
				$o="=";
				$a=0;
				$inverted=0;
				$l=length($val);
				# print("Doing flags on \"$val\" ($l)\n");
				for($j=0;$j<$l;$j++){
					$v = substr($val,$j,1);
					# print("L: $v, ");
					if($v eq ' '){
					} elsif($v eq '+'){
						$o = "mask_all";
					} elsif($v eq '*'){
						$o = "mask";
					} elsif($v eq '!'){
						$inverted=1;
					} elsif($v eq '0'){
						# $a |= 0;
					} elsif($v eq '1'){
						$a |= 1<<7;
					} elsif($v eq '2'){
						$a |= 1<<6;
					} elsif($v eq 'U'){
						$a |= 1<<5;
					} elsif(($v eq 'A')|| ($v eq 'a')){
						# print("GOT A!\n");
						$a |= 1<<4;
					} elsif($v eq 'P'){
						$a |= 1<<3;
					} elsif($v eq 'R'){
						$a |= 1<<2;
					} elsif($v eq 'S'){
						$a |= 1<<1;
					} elsif($v eq 'F'){
						$a |= 1<<0;
					} else {
						print(STDERR "AIEE!  Unrecognized TCP flag: $v.\n");
						# exit(-1);
					}
				}
				if($inverted){ print("<NOT>");}
				my $lproto=&mylc($headers[1]);
				if($o eq "mask_all"){
					print "\t\t\t<PRIM proto=\"$lproto\" field=\"flags\" op=\"$o\">$a:$a</PRIM>";
				} else {
					print "\t\t\t<PRIM proto=\"$lproto\" field=\"flags\" op=\"$o\">$a</PRIM>";
				}
				if($inverted){ print("</NOT>");}
				print("\n");

			} elsif($op =~ /dsize/){
				$val =~ s/ //g;
				$o="=";
				if($val =~ /&gt;/){
					$val =~ s/&gt;//g;
					$o = "&gt;";
				} elsif ($val =~ /&lt;/){
					$val =~ s/&lt;//g;
					$o = "&lt;";
				}
				my $lproto=&mylc($headers[1]);
				if($lproto eq "ip" || $lproto eq "ipv4"){
					# ipv4: ipv4 payload = > <
					print "\t\t\t<PRIM proto=\"ipv4\" field=\"payload\" op=\"$o\">$val</PRIM>\n";
				} elsif($lproto eq "udp"){
					# tcp:  tcp payload = > <
					print "\t\t\t<PRIM proto=\"udp\" field=\"payload\" op=\"$o\">$val</PRIM>\n";
				} elsif($lproto eq "tcp"){
					# udp:  udp payload = > <
					print "\t\t\t<PRIM proto=\"tcp\" field=\"payload\" op=\"$o\">$val</PRIM>\n";
				} elsif($lproto eq "icmp"){
					# icmp: icmp payload = > <
					$val += 4;
					print "\t\t\t<PRIM proto=\"icmp\" field=\"payload\" op=\"$o\">$val</PRIM>\n";
				} else {
					print(STDERR "AIEE!  Unrecognized protocol: $lproto.  Aborting.\n");
					exit(-1);
				}

			} elsif($op =~ /offset/){
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/^ *//g; $val =~ s/ *$//g;
				$offset=$val;
				$has_content=1;

			} elsif($op =~ /depth/){
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				# skipped
				$val =~ s/^ *//g; $val =~ s/ *$//g;
				$depth=$val;
				$has_content=1;

			} elsif($op =~ /nocase/){
				$nocase=1;
				$has_content=1;
			
			} elsif($op =~ /itype/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				print "\t\t\t<PRIM proto=\"icmp\" field=\"type\" op=\"=\">$val</PRIM>\n";
			} elsif ($op =~ /icode/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				print "\t\t\t<PRIM proto=\"icmp\" field=\"code\" op=\"=\">$val</PRIM>\n";
			} elsif ($op =~ /seq/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				print "\t\t\t<PRIM proto=\"tcp\" field=\"sequence_no\" op=\"=\">$val</PRIM>\n";
			} elsif ($op =~ /ack/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				print "\t\t\t<PRIM proto=\"tcp\" field=\"ack_no\" op=\"=\">$val</PRIM>\n";
			} elsif ($op =~ /ipopts/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				if ($val=='rr') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"record_route_option\" op=\"present\"/>\n";

# FIXME: I think that this is Markus's comment.  I'm not sure that I understand
# it.  -- tlewis Fri Nov  9 17:19:33 EST 2001
# EOL and NOP don't seem to be tagged the same way the others are.  If they
# are, how do I identify them?
#				} elsif ($val=='eol') {
#				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"\" op=\"present\"/>\n";
#				} elsif ($val=='nop') {
#				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"\" op=\"present\"/>\n";

				} elsif ($val=='ts') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"internet_timestamp_option\" op=\"present\"/>\n";
				} elsif ($val=='sec') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"security_option\" op=\"present\"/>\n";
				} elsif ($val=='lsrr') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"loose_source_and_record_route_option\" op=\"present\"/>\n";
				} elsif ($val=='ssrr') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"strict_source_and_record_route_option\" op=\"present\"/>\n";
				} elsif ($val=='satid') {
				  print "\t\t\t<PRIM proto=\"ipv4\" section=\"stream_identifier\" op=\"present\"/>\n";
				} else {
				($comment = $options[$i]) =~ s/--/- -/g;
				  print("\t\t\t<!-- SKIPPED: $comment ($op) $val -->\n");
				}

			} elsif ($op =~ /rpc/) {
				($comment = $options[$i]) =~ s/--/- -/g;
				print("\t\t\t<!-- $comment -->\n");
				$val =~ s/ //g;
				($rpc_prog,$rpc_proc,$rpc_vers)=split(/,/,$val);
				print "\t\t\t<PRIM proto=\"oncrpc\" section=\"call_body\" field= \"prog\" op=\"=\">$rpc_prog</PRIM>\n";
				unless ($rpc_proc=='*') {
				  print "\t\t\t<PRIM proto=\"oncrpc\" section=\"call_body\" field= \"proc\" op=\"=\">$rpc_proc</PRIM>\n";
				}
				unless ($rpc_vers=='*') {
				  print "\t\t\t<PRIM proto=\"oncrpc\" section=\"call_body\" field= \"vers\" op=\"=\">$rpc_vers</PRIM>\n";
				}
				

			} elsif($op =~ /sameip/){
				  print "\t\t\t<PRIM proto=\"ipv4\" field= \"source\" op=\"sameip\"\/>\n";

			# } elsif($op =~ //){
			} else {
				$options =~ s/--/- -/g;
				print("\t\t\t<!-- SKIPPED: $options[$i] ($op) -->\n");
			}
		}
		if($has_content){
			# spit it out
			# print("NO CONTENT MATCH: $op\n");
			my $lproto=&mylc($headers[1]);
			if($lproto eq "icmp"){ # God does this suck.
				$offset += 4;
			}
			if($nocase){
				print "\t\t\t<PRIM proto=\"$lproto\" field=\"payload\" op=\"acbm_nocase_match\">$offset,$depth,$content</PRIM>\n";
			} else {
				print "\t\t\t<PRIM proto=\"$lproto\" field=\"payload\" op=\"acbm_case_match\">$offset,$depth,$content</PRIM>\n";
			}
			$content=$offset=$depth=$nocase='';
			$has_content=0;
		}

		# print "\t\t\t$header\n";
		# print "\t\t\t$options\n";

		print("\t\t</AND>\n");
		print("\t</match>\n");
		print "</rule>\n\n";

	} elsif (/^include/){
		&check_header();
		$header=0;
		@A=split;
		if(fork()){
			wait;
		} else {
			# print("execing cat $A[1] | $0 0\n");
			exec("cat $RULES_DIR/$A[1] | $0");
		}
	} else {
		@A=split;
		printf(STDERR "AIEE!  Unrecognized keyword: $A[0]\n");
	}
}

$mode && print("\n</rules>\n</hank-rules>\n");
