#include "system_log.h"
#include "hank.h"
#include <syslog.h>

static char rcsid[] = "$Id: system_log_syslog.c,v 1.4 2001/11/10 01:45:33 tlewis Exp $";

static int my_init(void);
static int my_close(void);
static int my_configure(char * config);
static int my_log(char *msg, unsigned int facility, unsigned int priority);

struct system_log slog = {
   {
      "syslog",
      1,
      1,
      &configurator_xml
   },
	&my_init,
	&my_close,
	&my_configure,
	&my_log,
	~0U,
	~0U
};

static int 
my_init(void)
{
	openlog("hank", LOG_PID, LOG_DAEMON);
	return(0);
}

static int 
my_close(void)
{
	closelog();
	return(0);
}

static int 
my_configure(char * config)
{
	/* No configuration */
	if(config==(char*)0)
		return(-1);
	return(0);
}

static int 
my_log(char *msg, unsigned int facility, unsigned int priority)
{
	if(facility>(8*sizeof(slog.fac_mask)))
		return(-1);
	if(priority>(8*sizeof(slog.pri_mask)))
		return(-1);

	if((slog.fac_mask & 1<<facility) && (slog.pri_mask & 1<<priority)) {
		syslog((int)priority, "%s: %s", slfacilities[facility], msg);
	}
	return(0);
}

