#include "packet.h"
#include "hank.h"
#include "paengine.h"
#ifndef   __USE_BSD
#define   __USE_BSD
#endif /* __USE_BSD */
#include <stdio.h>

static char rcsid[] = "$Id: test_pcap.c,v 1.4 2001/11/10 01:45:33 tlewis Exp $";

extern struct paengine pae;

int
main(int argc, char *argv[])
{
	int i;
	struct packet *p;
	size_t st = 0;

	if(argc!=2){
		fprintf(stderr, "Usage: %s <arg>\n", argv[0]);
		exit(-1);
	}

	if((i=pae.init())!=0){
		fprintf(stderr, "init() returned %i; exiting.\n", i);
		exit(i);
	}

	if((i=pae.configure(argv[1]))!=0){
		fprintf(stderr, "configure () returned %i; exiting.\n", i);
		exit(i);
	}

	i=0;

	while((p=pae.get_packet())!=NULL){
		st += p->encaps->length;
		printf("packet %i: proto=%i, len=%i, total=%i\n", i++, p->encaps->protocol,
			p->encaps->length, st);
		pae.dispose_packet(p);
	}

	exit(0);
}
